/*******************************************************************************
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 *******************************************************************************/

/**
 * Created by porcherg
 * Date: 09/05/11
 * Time: 16:24
 */
package org.ow2.orchestra.designer.bpmn.views {
  import flash.display.DisplayObject;

  import mx.binding.utils.BindingUtils;
  import mx.controls.Label;
  import mx.events.ResizeEvent;

  import org.ow2.orchestra.designer.bpmn.model.AbstractElement;
  import org.ow2.orchestra.designer.bpmn.model.PoolModel;

  public class PoolView extends AbstractElementView {
    [Bindable]
    private var _model:PoolModel;

    [Embed(source='/../assets/fonts/Tuffy/Tuffy-Regular.ttf',
            fontName='tuffy',
            mimeType='application/x-font',
            advancedAntiAliasing='true'
            )]
    private var font:Class;

    private var nameLabel:Label = new Label();

    public function PoolView(poolModel:PoolModel) {
      _model = poolModel;
      this.percentWidth = 100;
      this.nameLabel.percentWidth = 100;
      this.height = PoolModel.POOL_HEIGHT - 10;
      watchers.addItem(BindingUtils.bindProperty(this, "x", _model, "x"));
      watchers.addItem(BindingUtils.bindProperty(this, "y", _model, "y"));
      this.addEventListener(ResizeEvent.RESIZE, onResize);
      this.addChild(nameLabel);
    }

    private function onResize(event:ResizeEvent):void {
      this.graphics.clear();
      this.graphics.lineStyle(1);
      nameLabel.setStyle("fontFamily", "tuffy");
      nameLabel.text = _model.name;
      nameLabel.setStyle("paddingLeft", (this.width + nameLabel.measureText(nameLabel.text).width) / 2);
      this.graphics.beginFill(0xcccccc, 0.8);
      this.graphics.drawRect(0, 0, this.width, this.height);
      this.graphics.endFill();
    }

    override public function get model():AbstractElement {
      return _model;
    }

    override public function copy():AbstractElementView {
      return new PoolView(_model);
    }

    override public function get borderImage():DisplayObject {
      return this;
    }

    override public function get subtypeImage():DisplayObject {
      return null;
    }
  }
}
